# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CustomResourceactionsBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'display_name': 'str',
        'description': 'str',
        'provider_name': 'str',
        'resource_type': 'str',
        'status': 'str',
        'project_id': 'str',
        'org_id': 'str',
        'runnable_item': 'FormserviceapicustomresourcetypesMainActionsAllocate',
        'form_definition': 'FormserviceapicustomresourcetypesFormDefinition',
        'criteria': 'FormserviceapicustomresourcetypesCriteria'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'display_name': 'displayName',
        'description': 'description',
        'provider_name': 'providerName',
        'resource_type': 'resourceType',
        'status': 'status',
        'project_id': 'projectId',
        'org_id': 'orgId',
        'runnable_item': 'runnableItem',
        'form_definition': 'formDefinition',
        'criteria': 'criteria'
    }

    def __init__(self, id=None, name=None, display_name=None, description=None, provider_name=None, resource_type=None, status=None, project_id=None, org_id=None, runnable_item=None, form_definition=None, criteria=None):  # noqa: E501
        """CustomResourceactionsBody - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._display_name = None
        self._description = None
        self._provider_name = None
        self._resource_type = None
        self._status = None
        self._project_id = None
        self._org_id = None
        self._runnable_item = None
        self._form_definition = None
        self._criteria = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if display_name is not None:
            self.display_name = display_name
        if description is not None:
            self.description = description
        if provider_name is not None:
            self.provider_name = provider_name
        if resource_type is not None:
            self.resource_type = resource_type
        if status is not None:
            self.status = status
        if project_id is not None:
            self.project_id = project_id
        if org_id is not None:
            self.org_id = org_id
        if runnable_item is not None:
            self.runnable_item = runnable_item
        if form_definition is not None:
            self.form_definition = form_definition
        if criteria is not None:
            self.criteria = criteria

    @property
    def id(self):
        """Gets the id of this CustomResourceactionsBody.  # noqa: E501


        :return: The id of this CustomResourceactionsBody.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CustomResourceactionsBody.


        :param id: The id of this CustomResourceactionsBody.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this CustomResourceactionsBody.  # noqa: E501


        :return: The name of this CustomResourceactionsBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CustomResourceactionsBody.


        :param name: The name of this CustomResourceactionsBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def display_name(self):
        """Gets the display_name of this CustomResourceactionsBody.  # noqa: E501


        :return: The display_name of this CustomResourceactionsBody.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this CustomResourceactionsBody.


        :param display_name: The display_name of this CustomResourceactionsBody.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this CustomResourceactionsBody.  # noqa: E501


        :return: The description of this CustomResourceactionsBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CustomResourceactionsBody.


        :param description: The description of this CustomResourceactionsBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def provider_name(self):
        """Gets the provider_name of this CustomResourceactionsBody.  # noqa: E501


        :return: The provider_name of this CustomResourceactionsBody.  # noqa: E501
        :rtype: str
        """
        return self._provider_name

    @provider_name.setter
    def provider_name(self, provider_name):
        """Sets the provider_name of this CustomResourceactionsBody.


        :param provider_name: The provider_name of this CustomResourceactionsBody.  # noqa: E501
        :type: str
        """

        self._provider_name = provider_name

    @property
    def resource_type(self):
        """Gets the resource_type of this CustomResourceactionsBody.  # noqa: E501


        :return: The resource_type of this CustomResourceactionsBody.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this CustomResourceactionsBody.


        :param resource_type: The resource_type of this CustomResourceactionsBody.  # noqa: E501
        :type: str
        """

        self._resource_type = resource_type

    @property
    def status(self):
        """Gets the status of this CustomResourceactionsBody.  # noqa: E501


        :return: The status of this CustomResourceactionsBody.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this CustomResourceactionsBody.


        :param status: The status of this CustomResourceactionsBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["RELEASED", "DRAFT"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def project_id(self):
        """Gets the project_id of this CustomResourceactionsBody.  # noqa: E501


        :return: The project_id of this CustomResourceactionsBody.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this CustomResourceactionsBody.


        :param project_id: The project_id of this CustomResourceactionsBody.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def org_id(self):
        """Gets the org_id of this CustomResourceactionsBody.  # noqa: E501


        :return: The org_id of this CustomResourceactionsBody.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this CustomResourceactionsBody.


        :param org_id: The org_id of this CustomResourceactionsBody.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def runnable_item(self):
        """Gets the runnable_item of this CustomResourceactionsBody.  # noqa: E501


        :return: The runnable_item of this CustomResourceactionsBody.  # noqa: E501
        :rtype: FormserviceapicustomresourcetypesMainActionsAllocate
        """
        return self._runnable_item

    @runnable_item.setter
    def runnable_item(self, runnable_item):
        """Sets the runnable_item of this CustomResourceactionsBody.


        :param runnable_item: The runnable_item of this CustomResourceactionsBody.  # noqa: E501
        :type: FormserviceapicustomresourcetypesMainActionsAllocate
        """

        self._runnable_item = runnable_item

    @property
    def form_definition(self):
        """Gets the form_definition of this CustomResourceactionsBody.  # noqa: E501


        :return: The form_definition of this CustomResourceactionsBody.  # noqa: E501
        :rtype: FormserviceapicustomresourcetypesFormDefinition
        """
        return self._form_definition

    @form_definition.setter
    def form_definition(self, form_definition):
        """Sets the form_definition of this CustomResourceactionsBody.


        :param form_definition: The form_definition of this CustomResourceactionsBody.  # noqa: E501
        :type: FormserviceapicustomresourcetypesFormDefinition
        """

        self._form_definition = form_definition

    @property
    def criteria(self):
        """Gets the criteria of this CustomResourceactionsBody.  # noqa: E501


        :return: The criteria of this CustomResourceactionsBody.  # noqa: E501
        :rtype: FormserviceapicustomresourcetypesCriteria
        """
        return self._criteria

    @criteria.setter
    def criteria(self, criteria):
        """Sets the criteria of this CustomResourceactionsBody.


        :param criteria: The criteria of this CustomResourceactionsBody.  # noqa: E501
        :type: FormserviceapicustomresourcetypesCriteria
        """

        self._criteria = criteria

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CustomResourceactionsBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomResourceactionsBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
